import java.awt.Color;

public class Model {
	Point center;
	PointList points;
	Poly[] plist;
	int pnum;
	boolean abs = false;
	//-----------------------------------------
	//constructor
	//-----------------------------------------
	public Model(String str) {
		String[] poly = str.split("\n");
		String[] point = poly[0].split(" ");
		this.center = new Point();
		this.points = new PointList(point.length);
		this.plist = new Poly[poly.length];
		this.pnum = 0;
		this.compose(str);
	}
	//----------------------------------------
	//ultimately usefull
	//----------------------------------------
	//all this because i wanted point to never duplicate , but i wanted to be able
	//to duplicate an entire model , and the easiest way was to keep only index to
	//point in polygon . so polygon keep a number who index a point in the point list.
	//then just give the point number in polygon and the polygon number , it will return the point
	//this.points.list = { Point1, Point2, ...}
	//this.polygons.list = { Poly1, Poly2, ...}
	//this.polygons.list[0] = Poly1;
	//Poly1.list[0] = 1 (example that the first point of the poly is the Point2);
	//this.points.list[1] = Point2;
	public Point get_point_of_poly(int numpoint, int numpoly) {
		return this.points.list[ this.plist[numpoly].list[numpoint] ];
	}
	//----------------------------------------
	//opperation transmitted to point
	//----------------------------------------
	public void move(double x, double y, double z){
		if (this.abs == true) {
			for (int i = 0; i<this.points.num; i++) {
				this.points.list[i].add(x,y,z);
			}
		}
		center.add(x,y,z);
	}
	public void rotate_x(double r) {
		for (int i = 0; i<this.points.num; i++) {
			this.points.list[i].rotate_x(r);
		}
	}
	public void rotate_y(double r) {
		for (int i = 0; i<this.points.num; i++) {
			this.points.list[i].rotate_y(r);
		}
	}
	public void rotate_z(double r) {
		for (int i = 0; i<this.points.num; i++) {
			this.points.list[i].rotate_z(r);
		}
	}
	//-------------------------------------------
	//absolute/relative  if relative , all point are around center
	//-------------------------------------------
	public void absolute() {
		//point + vector
		if (this.abs == false) {
			for (int i = 0; i<this.points.num; i++) {
				this.points.list[i].add(this.center);
			}
			this.abs = true;
		}
	}
	public void relative() {
		//point - vector
		if (this.abs == true) {
			for (int i = 0; i<this.points.num; i++) {
				this.points.list[i].sub(this.center);
			}
			this.abs = false;
		}
	}
	//-------------------------------------------
	//compositor
	//-------------------------------------------
	//why part of the compsitor is not inside the polygon object , because it need acces to Model.points
	//do something about optional backface culling
	public void compose(String str) {
			String[] polys = str.split("\n");				//extract polygon from string (separated by newline)
			for (int i=0; i<polys.length; i++) {
				String[] points = polys[i].split(" ");		//extract point from polygon string (sparated by whitespace)
				Poly poly = new Poly(points.length);
				for (int j = 0; j<points.length; j++) {
					String[] comps = points[j].split(":");	//extract x,y,z from point string (separated by : like x:y:z) 
					double x = Double.parseDouble(comps[0]);
					double y = Double.parseDouble(comps[1]);
					double z = Double.parseDouble(comps[2]);
					//if it is the first trio , then it is the color
					if (j == 0) {
						//make it fail safe (0-1)
						poly.color = new Color((int)(x*255),(int)(y*255),(int)(z*255));
					}
					else if (j == 1) {
						//make it fail safe (0-1)
						poly.border = new Color((int)(x*255),(int)(y*255),(int)(z*255));
					}
					else {
						//add point only if not already in list
						int point = -1;
						for (int h = 0; h < this.points.num; h++) {
							if ( (this.points.list[h].x == x)&&(this.points.list[h].y == y)&&(this.points.list[h].z == z) ) {
								point = h;
							}
						}//because many polygons can share the same point
						if (point == -1) {
							point = this.points.append(new Point(x,y,z));	//return point number in the points.list[]
						}
						//the second argument is not to plug but the face vector
						//still on the point list, but un connected with other in polygon
						//polygon keep it in face argument, use it for back face culling
						if (point != -1) {
							if (poly.num < poly.list.length) {
								poly.list[poly.num] = point;
								poly.num += 1;
							}
						}
					}
				}
				if (this.pnum < this.plist.length) {
					this.plist[this.pnum] = poly;
					this.pnum += 1;
				}
			}
	}
	//===================================================================================================================================
	//polygon
	//===================================================================================================================================
	public class Poly {
		int[] list;	//list of Point index in PointList
		int num;	//easier to dupe poly with only index
		Color color;
		Color border;
		Boolean backface_culling = true;	//make the back face culling optional per polygon
							//find a cool way to declare it
		//---------------------------------------------------------
		//constructor
		//---------------------------------------------------------
		public Poly(int n) {
			if (n < 3) {
				n = 3;		//a polygone have at least 3 point
			}
			this.list = new int[n];
			this.num = 0;
		}
	}
		//---------------------------------------------------------
		//end
		//---------------------------------------------------------
	//===================================================================================================================================
	//polygon
	//===================================================================================================================================

	//-------------------------------------------------------------------------------------------------------------------------------------------------
	//end
	//-------------------------------------------------------------------------------------------------------------------------------------------------
}
